var Closure = require("bn-lang").Closure;

var TimerTask = function(){this.init.apply(this, arguments);};
exports.TimerTask = TimerTask;

/**
* @class TimerTask
* @constructor
* @param {Function} _block
* @param {Object} _object
* @param {Array} _args
* @param {Number} _runInterval
*/
TimerTask.prototype.init = function(_block, _object, _args, _runInterval) {

	this.block = _block;
	this.object = _object;
	this.args = _args;

	this.tickCount = _runInterval;

	this.currentTick = this.tickCount;
	this.running = false;
};

TimerTask.prototype.start = function() {

	this.running = true;
};

TimerTask.prototype.stop = function() {

	this.running = false;
};

TimerTask.prototype.run = function() {

	this.currentTick--;
	if (this.currentTick <= 0) {

		if(this.running) {

			new Closure().bind(this.block, this.object, this.args || [])();
		}

		// reset the this.currentTick from the original this.tickCount
		this.currentTick = this.tickCount;
	}
};

TimerTask.prototype.isRunning = function() {

	return this.running;
};
